import Vue = require('vue');
export declare class WatchOptions {
    expression: string;
    options: {
        handler: Vue.WatchHandler;
    } & Vue.WatchOptions;
}
export declare class VueTypescriptComponentData {
    props: {
        [index: string]: Vue.PropOptions;
    };
    watch: {
        [index: string]: Array<WatchOptions>;
    };
}
/** Use field as property
 * If field is initialized, sets default value and type. Otherwise mark as required
 */
export declare function prop(options?: Vue.PropOptions): (target: any, member: string) => void;
/** Use method(val, oldVal) to watch expression
 * The method is still part of the `method` object and it is possible to use multiple @watch
 * annotations to watch multiple expressions with one string
 */
export declare function watch(expression: string, options?: Vue.WatchOptions): (target: any, member: string) => void;
export interface NoArgumentConstructable {
    new (): any;
    vueComponentOptions?: Vue.ComponentOptions;
}
/** Create vueComponentOptions constructor property based on method/field annotations
 *  if provided, use options as the base value (.data is always overriden)
 */
export declare function component(options?: Vue.ComponentOptions): (cls: NoArgumentConstructable) => void;
